.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include shell32.inc
includelib shell32.lib

;***************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

InitTray proto hwnd:DWORD,pIconData:DWORD

;***************************************************************************************************

IDI_ICON32      equ 100
IDI_ICON16      equ 101

WM_TRAY         equ WM_USER+150
IDI_TRAY        equ 5000

WIN_WIDTH       equ 320
WIN_HEIGHT      equ 240

;***************************************************************************************************

.data
AppName     db "TrayIcon",0
ClassName   db "TrayIcon",0
tooltip     db "Left-click me to exit.",0
hehe        db "The OTHER left!",0

.data?
hInstance   HINSTANCE       ?
hWnd        HWND            ?
iconData    NOTIFYICONDATA <?>

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;***************************************************************************************************

WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    push edi
    lea edi,[wc]
    assume edi:ptr WNDCLASSEX
    mov [edi].cbSize,SIZEOF wc
    mov [edi].style,CS_HREDRAW or CS_VREDRAW
    mov [edi].lpfnWndProc,OFFSET WndProc
    mov eax,hInstance
    mov [edi].hInstance,eax
    invoke LoadIcon, hInstance,IDI_ICON32
    mov [edi].hIcon,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov [edi].hCursor,eax
    mov [edi].hbrBackground,COLOR_WINDOW+1
    mov [edi].lpszClassName,OFFSET ClassName
    xor eax,eax
    mov [edi].cbClsExtra,eax
    mov [edi].cbWndExtra,eax
    mov [edi].lpszMenuName,eax
    mov [edi].hIconSm,eax
    invoke RegisterClassEx, edi
    invoke CreateWindowEx, NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,WIN_WIDTH,WIN_HEIGHT,NULL,NULL,hInstance,NULL
    .IF (eax)
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        lea edi,[msg]
        assume edi:ptr MSG
        .WHILE TRUE
            xor eax,eax
            invoke GetMessage, edi,eax,eax,eax
            .BREAK .IF(!eax)
            invoke TranslateMessage, edi
            invoke DispatchMessage, edi
        .ENDW
        mov eax,[edi].wParam
    .ENDIF
    assume edi:nothing
    pop edi
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;-- WM_TRAY ----------------------------------------------------------------------------------------
    .IF (eax==WM_TRAY)
        .IF (wParam==IDI_TRAY)
            .IF (lParam==WM_LBUTTONDOWN)
                invoke SendMessage, hwnd,WM_CLOSE,NULL,NULL     ;tray icon left-clicked -- just close
            .ELSEIF (lParam==WM_RBUTTONDOWN)
                invoke MessageBox, hwnd,ADDR hehe,ADDR AppName,MB_OK or MB_ICONEXCLAMATION
            .ENDIF
        .ENDIF
;-- WM_CREATE --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke InitTray, hwnd,ADDR iconData                     ;set the tray icon
;-- WM_DESTROY -------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke Shell_NotifyIcon, NIM_DELETE,ADDR iconData       ;remove the tray icon
        invoke PostQuitMessage, NULL
;-- default ----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

InitTray proc hwnd:DWORD,pIconData:DWORD
    push edi
    mov edi,pIconData
    assume edi:ptr NOTIFYICONDATA
    mov [edi].cbSize,SIZEOF NOTIFYICONDATA
    mov eax,hwnd
    mov [edi].hwnd,eax
    mov [edi].uID,IDI_TRAY
    mov [edi].uFlags,NIF_ICON or NIF_MESSAGE or NIF_TIP
    mov [edi].uCallbackMessage,WM_TRAY
    invoke LoadIcon, hInstance,IDI_ICON16
    mov [edi].hIcon,eax
    invoke lstrcpy, ADDR [edi].szTip,ADDR tooltip
    invoke Shell_NotifyIcon, NIM_ADD,edi
    assume edi:nothing
    pop edi
    ret
InitTray endp

end start
